' InfDatum.Inc  Prozedur: InfDatum
'
' Eine Beschreibung der Prozedur ist in InfDatum.prf enthalten

' Version 2.5  07.03.2005.     Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka
'                       email: g.putschalka@web.de
'                    homepage: http://members.telering.at/g.putschalka/index.html

' ==== Prozedur. Die Definitionen und die Bereichsvariable sind global, liegen also auerhalb der Prozedur !!
Def ToSystemTime(2)   ! "KERNEL32","FileTimeToSystemTime"
Def FromSystemTime(2) ! "KERNEL32","SystemTimeToFileTime"
Declare Q_Datum#,Q_FileTime#,AnzTge$

' Hilfsprozeduren
' =============
Proc Bestimme_Schaltjahr
   Declare Jhr%,Jhr$
   Let Jhr% = @Val(@Right$(@Str$(@Word(Q_Datum#,0)),2))
   Let Jhr$ = @str$(@Word(Q_Datum#,0))
   Let Jhr% = @Mod(@Word(Q_Datum#,0),4) ' ob durch 4 teilbar (ohne Rest)
   Case @Equ$(@Right$(Jhr$,2),"00")  : Let Jhr% = 1 ' kein Schaltjahr bei Jahrhundert
   Case @Equ$(@Right$(Jhr$,3),"000") : Let Jhr% = 0 ' jedoch bei Jahrtausend

   ' lschen nicht benutzter Bereiche
   WORD Q_Datum#,8 = 0
   WORD Q_Datum#,10 = 0
   WORD Q_Datum#,12 = 0
   WORD Q_Datum#,14 = 0

   ' feststellen Tage im Jahr - pro Monat aufgerechnet
   If (Jhr% = 0)
      AnzTge$ = "000031060091121152182213244274305335" ' Schaltjahr
      WORD Q_Datum#,31 = 366
   Else
      AnzTge$ = "000031059090120151181212243273304334"
      WORD Q_Datum#,31 = 365
   EndIf
   Return
Endproc

Proc Berechne_Erste_Kalenderwoche
   Declare SavJ&,SavM&,SavT&,SavA&,SavZ$,WoTab$,B&

   WoTab$ = "0201;0101;3112;3012;2912;0401;0301"

   ' setze 1.1 des Jahres um den Wochentag zu bestimmen
   WORD Q_Datum#,2  = 1
   WORD Q_Datum#,6  = 1
   WORD Q_Datum#,18 = 0

   ' konvertiere in Filetime und zurck in Systemtime um den Wochentag zu erhalten
   Ret& = FromSystemTime(Q_Datum#,Q_FileTime#)
   ToSystemTime(Q_FileTime#,Q_Datum#)
   B&   = @Word(Q_Datum#,4)    ' Index zu Wochentag 

   SavJ& = @Word(Q_Datum#,0)   
   ' hole Monat und Tag aus der Tabelle
   SavZ$ = @Substr$(WoTab$,(B& + 1),";")
   SavM& = @Val(@Right$(SavZ$,2))
   SavT& = @Val(@Left$(SavZ$,2))
   If (SavM& = 12)
      SavJ& = (SavJ& - 1)
   EndIf

   Word Q_Datum#,18 = SavJ&
   Word Q_Datum#,25 = SavJ&
   Word Q_Datum#,23 = SavM&
   Word Q_Datum#,21 = SavT&

   Return
Endproc

Proc Berechne_Tag_Monat ' es ist das Jahr und der Tag im Jahr gegeben
   Declare X1%,X2%,Zw&
   ' Monat ist Null, somit wurde der Tag im Jahr angegeben (Julianisches Datum)
   ' daher den Tag im Monat bestimmen und gefundenen Monat einsetzen.
   Word Q_Datum#,16 = @Word(Q_Datum#,6) ' setze Tag im Jahr auf richtige Position
   Let X1% = 12
   While (@Word(Q_Datum#,2) = 0)
     Let X2% = ((X1% * 3) - 2)  ' Index zu AnzTge$
     Let Zw& = @Val(@Mid$(AnzTge$,X2%,3))
     If (@Word(Q_Datum#,6) > Zw&)
       Word Q_Datum#,6 = (@Word(Q_Datum#,6) - Zw&) ' setze Tag im Monat
       Word Q_Datum#,2 = X1%                       ' setze Monat
     EndIf
     Dec X1%
   EndWhile
   Return
Endproc

Proc Berechne_Tag_im_Jahr ' es ist Tag, Monat und Jahr gegeben
   Declare Mnt%,Tg%
    ' Tag im Jahr berechnen
    Let Mnt% = @Word(Q_Datum#,2)
    Let Tg%  = @Word(Q_Datum#,6)
    Let Mnt% = ((Mnt% * 3) - 2)  ' Index zu AnzTge$
    Let Mnt% = @Val(@Mid$(AnzTge$,Mnt%,3))
    Let Tg%  = (Mnt% + Tg%)
    WORD Q_Datum#,16 = Tg%
   Return
Endproc

Proc Berechne_neues_Datum ' Tage zum Datum addieren/subtrahieren
   Declare I%
   IfNot (@Char$(Q_Datum#,20,1) = "-") ' Anzahl Tage addieren
      Word Q_Datum#,16 = (@Word(Q_Datum#,16) + @Word(Q_Datum#,18))
      While (@Word(Q_Datum#,16) > @Word(Q_Datum#,31)) ' noch mehr als Tage im Jahr?
         Word Q_Datum#,16 = (@Word(Q_Datum#,16) - @Word(Q_Datum#,31))
         Word Q_Datum#,0 = (@Word(Q_Datum#,0) +1) ' erhhe Jahr
         Bestimme_Schaltjahr
      EndWhile
   Else                       ' Anzahl Tage subtrahieren
      If (@Word(Q_Datum#,18) > @Word(Q_Datum#,16))
      ' Subtage sind > eingegebener Tag. Datum kann daher nicht im aktuellen Jahr sein
      ' Falls Subtraktionstage > Anzahl Tage im Vorjahr sind, Jahr weiter vermindern und
      ' Subtraktionstage um Anzahl Tage im Vorjahr verringern
      I% = 1
         While I%
            Word Q_Datum#,0     = (@Word(Q_Datum#,0) - 1)
            Bestimme_Schaltjahr
            If (@Word(Q_Datum#,18) > @Word(Q_Datum#,31)) ' weiter reduzieren
               Word Q_Datum#,18  = (@Word(Q_Datum#,18) - @Word(Q_Datum#,31))
            Else
               I% = 0
            EndIf
         EndWhile
            Word Q_Datum#,0     = (@Word(Q_Datum#,0) + 1)
            Bestimme_Schaltjahr
      EndIf

      ' Behandlung wenn Subtraktionstage gleich, oder weniger oder mehr als ursprnglicher 
      ' Tag im Monat ist.
      If (@Word(Q_Datum#,16) = @Word(Q_Datum#,18))
         Word Q_Datum#,0     = (@Word(Q_Datum#,0) - 1)
         Bestimme_Schaltjahr
         Word Q_Datum#,16    = @Word(Q_Datum#,31)

      ElseIf (@Word(Q_Datum#,18) < @Word(Q_Datum#,16))
         Word Q_Datum#,16  = (@Word(Q_Datum#,16) - @Word(Q_Datum#,18))

      ElseIf (@Word(Q_Datum#,18) > @Word(Q_Datum#,16))      
         Word Q_Datum#,0     = (@Word(Q_Datum#,0) - 1)
         Bestimme_Schaltjahr
         Word Q_Datum#,16  = (@Word(Q_Datum#,31) - @Word(Q_Datum#,18) + @Word(Q_Datum#,16))
      EndIf
   EndIf

   Word Q_Datum#,6 = @Word(Q_Datum#,16)
   Word Q_Datum#,2 = 0
   Berechne_Tag_Monat
   FromSystemTime(Q_Datum#,Q_FileTime#)
   Return
Endproc


' Hauptprozedur
' =============
Proc InfDatum
   Declare Ret&,SMonat&,STag&,JTag&,Wtag&,Jhr%,Tg%
   Declare H%,H4%,F%,G%,M%,N%,A%,B%,C%,D%,E%,T%,M%

   Bestimme_Schaltjahr
   If (@Word(Q_Datum#,2) = 0) ' ist nur Tag und Jahr gegeben?
      Berechne_Tag_Monat
   Else
      Berechne_Tag_im_Jahr
   EndIf
   ' jetzt enthlt die Datenstruktur Tag, Monat, Jahr, Tagim Jahr und Anzahl Tage im Jahr

   ' Datum in FileFormat konvertieren. Prft gleichz. Gltigkeit.
   Ret& = FromSystemTime(Q_Datum#,Q_FileTime#)
   Case (Ret& = 0) : Return Ret&  ' beende hier, Datum ist falsch

   CaseNot (@Word(Q_Datum#,18) = 0) : Berechne_neues_Datum
   ' jetzt Datum wieder zurckkonvertieren (liefert den Wochentag)
   ToSystemTime(Q_FileTime#,Q_Datum#)

   ' feststellen 1. Tag der ersten Kalenderwoche (= Montag der ersten Kalenderwoche)
   SMonat& = @Word(Q_Datum#,2)  ' sichere neuen Tag
   STag&   = @Word(Q_Datum#,6)  ' sichere neuen Monat
   JTag&   = @Word(Q_Datum#,16) ' sichere neuen Tag im Jahr
   Wtag&   = @Word(Q_Datum#,4)  ' sichere neuen Wochentag

   Berechne_Erste_Kalenderwoche

   ' berechne Kalenderwoche zum aktuellen Tag
   If (@Word(Q_Datum#,23) = 1)  ' 1. Kalenderwoche ist in diesem Jahr
      Ret& = @Div&((@Word(Q_Datum#,16) - @Word(Q_Datum#,21) + 7),7)
   Else
      Ret& = @Div&((31 - @Word(Q_Datum#,21) + @Word(Q_Datum#,16) +7),7)
   EndIf
   WORD Q_Datum#,8 = Ret&

   ' berechne Palmsonntag
   Let Jhr% = @Word(Q_Datum#,0)
   Let H%   = @Int(Jhr% / 100)
   Let H4%  = @Int(H% / 4)
   Let F%   =  @Int((H% - 17) / 25)
   Let G%   =  @Int((H% - F%) / 3)
   Let N%   = @mod((4 + H% - H4%),7)
   Let M%   = @Mod((15 + H% - H4% - G%),30)
   Let A%   = @mod(Jhr%,19)
   Let B%   = @mod(Jhr%,4)
   Let C%   = @mod(Jhr%,7)
   Let D%   = @mod(((19 * A%) + M%),30)
   Let E%   = @mod(((2 * B%) + (4 * C%) + (6 * D%) + N%),7)
   Let T%   = (D% + E% +15)
   Let M%   = 3
   If (T% > 31)     ' das Datum liegt im April
      Let T% = (T% - 31)
      Case (T% = 19) : T% = 12
      Case (T% = 18) and (D% = 28) and (E% = 6) and (A% > 10) : T% = 11
      M% = 4
   EndIf
   WORD Q_Datum#,27 = T%
   WORD Q_Datum#,29 = M%

   WORD Q_Datum#,2 = SMonat&       ' restore bergebenen Tag und Monat
   WORD Q_Datum#,4 = WTag&
   WORD Q_Datum#,6 = STag&
   WORD Q_Datum#,16 = JTag&
   Return 1
EndProc
' ======= Ende der Prozedur ========
